﻿using System;
using System.Text;
using System.IO;
using System.Runtime.Serialization.Json;
using Com.Bocom.OpenApi.Security.Sign;

namespace Com.Bocom.OpenApi
{
    namespace Utils
    {
        public class ApiUtils
        {
            public static Object ParseNotifyJsonWithBocomSign(string notifyStr, string charset, string APIGW_PUBLIC_KEY,
                Type T)
            {
                string bizContentStr;
                string sign;
                try
                {
                    int indexOfRootStart = notifyStr.IndexOf(BocomConstants.NOTIFY_BIZ_CONTENT)
                                           + BocomConstants.NOTIFY_BIZ_CONTENT.Length + 2;
                    int indexOfRootEnd = notifyStr.LastIndexOf(",");
                    int indexOfSignStart =
                        notifyStr.LastIndexOf(BocomConstants.SIGN + "\"") + BocomConstants.SIGN.Length + 3;
                    int indexOfSignEnd = notifyStr.LastIndexOf("\"");
                    bizContentStr = notifyStr.Substring(indexOfRootStart, indexOfRootEnd - indexOfRootStart);
                    sign = notifyStr.Substring(indexOfSignStart, indexOfSignEnd - indexOfSignStart);
                }
                catch (Exception e)
                {
                    throw new Exception("notify_biz_content is not format json. notifyStr :\n" + notifyStr, e);
                }

                Boolean passed = RSASignature.Verify(bizContentStr, APIGW_PUBLIC_KEY, charset, sign);
                if (!passed)
                {
                    throw new Exception("Bocom sign verify not passed.");
                }

                try
                {
                    //反序列化并返回
                    BocomResponse response;
                    MemoryStream ms1 = new MemoryStream(Encoding.GetEncoding(charset).GetBytes(bizContentStr));
                    using (MemoryStream ms = new MemoryStream(Encoding.GetEncoding(charset).GetBytes(bizContentStr)))
                    {
                        DataContractJsonSerializer deseralizer = new DataContractJsonSerializer(T);
                        response = (BocomResponse) deseralizer.ReadObject(ms) as BocomResponse;
                    }

                    return response;
                }
                catch (Exception e)
                {
                    throw new Exception("notify_biz_content can not transform to defined class. response: " + notifyStr
                                                                                                            + " defined class name: " +
                                                                                                            T, e);
                }
            }
        }
    }
}